
import java.util.concurrent.CompletableFuture;
import java.util.concurrent.ExecutionException;

/**
   Implement this task graph on a thread pool.

          task1            task2
            |             /
            |            /
          task3         /
         /     \       /
        /       \     /
   task4         task5
        \       /
         \     /
          task6
*/
public class TaskGraph_v4
{
   public static void main(String[] args)
   {
    //final int cores = Runtime.getRuntime().availableProcessors();
      final int cores = 2;
      final MyThreadPool_v1 executor = new MyThreadPool_v1(cores);

      final Task<Integer,Integer> task1 = new Task<>(1, 1, 2);
      final Task<Integer,Integer> task2 = new Task<>(2, 2, 4);
      final Task<Integer,Integer> task3 = new Task<>(3, 3, 2);
      final Task<Integer,Integer> task4 = new Task<>(4, 4, 1);
      final Task<Integer,Integer> task5 = new Task<>(5, 5, 3);
      final Task<Integer,Integer> task6 = new Task<>(6, 6, 2);

      final CompletableFuture<Integer> future1 = new CompletableFuture<>(); // empty future
      final CompletableFuture<Integer> future2 = new CompletableFuture<>(); // empty future

      final Runnable r1 = ()->{try{ task1.run();
                                    task3.run();
                                    future1.complete(0); // Send a message.
                                    task4.run();
                                    future2.get();       // Receive a message.
                                    task6.run();
                                  }catch(InterruptedException
                                        |ExecutionException e){}
                              };

      final Runnable r2 = ()->{try{ task2.run();
                                    future1.get();       // Receive a message.
                                    task5.run();
                                    future2.complete(0); // Send a message.
                                  }catch(InterruptedException
                                        |ExecutionException e){}
                              };

      executor.execute( r1 );
      executor.execute( r2 );

      executor.shutdown();
   }
}
